//+------------------------------------------------------------------+
//|                                                  cfb channel.mq4 |
//|                                                           mladen |
//|                                               mladenfx@gmail.com |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  Red
#property indicator_color2  DimGray
#property indicator_color3  Green
#property indicator_style1  STYLE_DOT
#property indicator_style3  STYLE_DOT

//
//
//
//
//

extern int  CfbDepth        = 1;
extern int  CfbPrice        = PRICE_WEIGHTED;
extern int  CfbSmooth       = 8;
extern int  CfbResultSmooth = 1;
extern int  Depth1          = 10;
extern int  Depth2          = 20;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
int    Ignore;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   
      int    Depths[] = {24,32,48,64,96,128,192};
   
   CfbDepth = MathMax(MathMin(CfbDepth,7),1);
   Ignore   = Depths[CfbDepth-1]+3;
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars  = IndicatorCounted();
   int i,depth,limit; 
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = Bars - counted_bars;

   //
   //
   //
   //
   //

   for(i = limit; i >= 0 ; i--)
   {
      double ratio = 0;
      double cfb   = iCustom(NULL,0,"cfb","",CfbDepth,CfbPrice,0,CfbSmooth,CfbResultSmooth,0,i);
         if (i>=(Bars-Ignore))
            {
               buffer4[i] = cfb;
               buffer5[i] = cfb;
            }
         else
            {
               buffer4[i] = MathMax(buffer4[i+1],cfb);
               buffer5[i] = MathMin(buffer5[i+1],cfb);
            }
         if (buffer4[i] != buffer5[i])
               ratio = (cfb-buffer5[i])/(buffer4[i]-buffer5[i]);
               depth = MathRound( Depth1 + ratio*(Depth2-Depth1));
 
      //
      //
      //
      //
      //
         
         if (High[i] > buffer1[i+1])
               buffer1[i] =  High[i];
         else  buffer1[i] = (High[iHighest(NULL,0,MODE_HIGH,depth,i)]+buffer1[i+1])/2.0;
         if (Low[i] < buffer3[i+1])
               buffer3[i] =  Low[i];
         else  buffer3[i] = (Low[iLowest(NULL,0,MODE_LOW,depth,i)]+buffer3[i+1])/2.0;
               buffer2[i] = (buffer1[i]+buffer3[i])/2.0;
   }
   return(0);
}